
/* Chrysalide - Outil d'analyse de fichiers binaires
 * quirks.h - prototypes pour la transmission du type Python exact aux instances de PyObject
 *
 * Copyright (C) 2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _PLUGINS_PYOIDA_QUIRKS_H
#define _PLUGINS_PYOIDA_QUIRKS_H


//#include <Python.h>
#include <glib-object.h>


#if 0
/* Définit les éléments immuables pour toute association. */
void pychrysalide_init_quirks(void);

/* Modifie les seuils de collecte pour le collecteur de Python. */
void pychrysalide_set_gc_threshold(int, int, int);

/* Crée l'association précise attendue par Python-GObject. */
void pychrysalide_set_instance_data(GObject *, PyTypeObject *);

/* Fournit l'instance Python d'une instance GLib, si existante. */
PyObject *pychrysalide_get_pygobject(GObject *);

/* Initialise un objet dérivé de GObject en Python. */
int pychrysalide_allow_args_for_gobjects(PyObject *, PyObject *, PyObject *);
#endif



/* Evite à Python d'avoir à manipuler les références internes. */
GObject *_get_internal_ref(GObject *);


#define define_internal_ref(r) _get_internal_ref(r)
#define get_internal_ref() _get_internal_ref(NULL)



#endif  /* _PLUGINS_PYOIDA_QUIRKS_H */
