
/* Chrysalide - Outil d'analyse de fichiers binaires
 * dynamic.h - prototypes pour la manipulation de l'en-ête de programme 'DYNAMIC'
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_ELF_DYNAMIC_H
#define _FORMAT_ELF_DYNAMIC_H


#include "elf.h"
#include "elf_def.h"



/* Recherche un en-tête de programme DYNAMIC au sein de binaire. */
bool find_elf_dynamic_program_header(const GElfFormat *, elf_phdr *);

/* Retrouve un élément donné dans la section dynamique. */
bool find_elf_dynamic_item_from_pheader(const GElfFormat *, const elf_phdr *, int64_t, elf_dyn *);



#endif  /* _FORMAT_ELF_DYNAMIC_H */
